/*	pfdefs.h			*/

typedef	unsigned ushort;
typedef	unsigned uint;
typedef int 	 (*PFI)();/* pointer to function returning int */
typedef	char 	 *HDL;	/* abstract data type handle */
typedef	long 	 RHDL;	/* database record handle */

/*	Some useful macros		*/
/**	General defines used almost everywhere 	**/

#define ABS(x) 		((x)<0?-(x):(x))
#define	BELL		7
#define BKSP		8
#define BLNK		' '
#define CPMEOF          0x1A		/* <ctl-z> byte for eof in text files*/
#define CRET            '\r'
#define	DELCH		0xff
#define	DIV2(x)		(((unsigned)(x))>>1)
#define	EOS		'\0'
#define EQ              0
#define ESC		27
#define	FAST		register
#define	FNAMSIZ		81
#define FOREVER 	for (;;)
#define FULLBYTE        ~0
#define GT              1
#define	HIBYTE(a)	(((unsigned)(a)) >> 8)
#define	INRANGE(a,b,c)	(((b)<(a))?(a):(((b)<(c))?(b):(c)))
#define	ISALPHA(c)	((('a'<=(c))&&((c)<='z')) || (('A'<=(c))&&((c)<='Z')))
#define	ISDIGIT(d)	(('0'<=(d))&&((d)<='9'))
#define	ISODD(a)	((a)&0x01)
#define LNFEED          '\n'
#define	LOBYTE(a)	((a)&0xff)
#define LT              (-1)
#define	MAKEWORD(hi,lo)	(TOHIBYTE(hi) | LOBYTE(lo))
#define MAX(a,b) 	(((a)>(b))?(a):(b))
#define MIN(a,b) 	(((a)<=(b))?(a):(b))
#define NO		0
#define	NOERR		0
#define NOTFND		(-1)	
/*	NULL's for various types of objects 	*/
#define NULLPTR		((char *)0) /* use to pass null pointer to funcs*/
#define NULLHDL		((HDL)0)
#define NULLVAL		((short)0)
#define NULLPFI		((PFI)0)
#define	NULLLONG	((long)0)
#define	NULLRHDL	((RHDL)0)
#define TAB             '\t'
#define	TIMES2(x)	((x)<<1)
#define TOHIBYTE(a)  	((a)<<8)
#define TOLOBYTE(a) 	(((a)>>8)&0xff)
#define	TOLOWER(c)	((('A' <= c) && (c <= 'Z')) ? ((c)+('a'-'A')):(c))
#define	TOUPPER(c)	((('a' <= c) && (c <= 'z')) ? ((c)-('a'-'A')):(c))
#define	YES		1

char	*sypushjmp();

#define	SYSETJMP	if (setjmp(sypushjmp())==0) {
#define	EXCEPTIONS	sypopjmp();} 
#define	WHEN(errnum)	else if (syerr()==(errnum)) 
#define	SYENDJMP	else sylongjmp(syerr());
#define	ALLOTHERS	syerr()

typedef struct
	{
	ushort	attr;/* attributes of file : system, hidden, directory etc.*/
	long	dttm;/* creation date and time of file */
	long	size;/* size of file in bytes */
	char	name[14];/* name of file (or directory) */
	}
FILEINFO;

/*	register values to use with various calls */

#define	REGIS	struct _REGIS

REGIS 	{ 
	uint	ax,bx,cx,dx,di,si,es,ds,bp;
	};

/*	Seek mode parameters for B-tree Keys		*/

/*	bkypos()	- position to new current key	*/

#define	BK_FSTDUP	-2	/* Seek first duplicate KEY value	*/
#define	BK_FST		-1	/* Seek first key in tree.		*/
#define	BK_LST		1	/* Seek last key in tree.		*/
#define	BK_LSTDUP	2	/* Seek last duplicate KEY value.	*/

/*	bkyscan()	- get current, next or previous key.		*/

#define	BK_PRV		-1	/* Retrieve previous key.		*/
#define	BK_CUR		0	/* Retrieve current key.		*/
#define	BK_NXT		1	/* Retrieve next key			*/

/*	bkysrch()	- search for a key.				*/

#define	BK_LT		-2	/* Seek key < KEY			*/
#define	BK_LE		-1	/* Seek key <= KEY			*/
#define	BK_EQ		0	/* Seek key == KEY			*/
#define	BK_GE		1	/* Seek key >= KEY			*/
#define	BK_GT		2	/* Seek key > KEY			*/

/*	Calendar Period types.				*/

#define	CAL_DAYS	0
#define	CAL_WKDAYS	1
#define	CAL_WKS		2
#define	CAL_MTHS	3
#define	CAL_QTRS	4
#define	CAL_YRS		5

/*	Calendar error indicators.			*/

#define CE_YR		1
#define CE_MTH		2
#define CE_DAY		3
#define CE_HR		4
#define CE_MIN		5
#define CE_SEC		6

/*	CM - communications values			*/

#define	CM_110BAUD	0x00
#define	CM_150BAUD	0x20
#define	CM_300BAUD	0x40
#define	CM_600BAUD	0x60
#define	CM_1200BAUD	0x80
#define	CM_2400BAUD	0xa0
#define	CM_4800BAUD	0xc0
#define	CM_9600BAUD	0xe0

#define	CM_7BITS	0x02
#define	CM_8BITS	0x03

#define	CM_NOPRTY	0x00
#define	CM_ODDPRTY	0x08
#define	CM_EVENPRTY	0x18

#define	CM_1STOP	0x00
#define	CM_2STOP	0x04

/*	types for shape of cursor.	*/

#define	CSR_HIDDEN 	0	/* no cursor.				*/
#define	CSR_THIN 	1	/* one scan line cursor.		*/
#define	CSR_NORMAL	2	/* two scan line cursor (standard)	*/
#define	CSR_FAT 	3	/* four lines.				*/
#define	CSR_BLOCK  	4	/* Block cursor.			*/
#define	CSR_DASH  	5	/* Dash in middle of character.		*/

/*	Use the current (logged-in) drive				*/

#define	DR_CUR_DRV	0

/*	Data type codes for search functions and B-trees.		*/

#define	DT_STR	 	1
#define	DT_USHORT	2
#define	DT_LONG		3
#define	DT_BYTES	4
#define	DT_SHORT	6
#define	DT_ULONG 	7 

/*		DOS	file attributes.			*/

#define	FA_ORDINARY	0x00		/* regular file.	*/
#define	FA_RDONLY	0x01		/* Read only attribute */
#define	FA_HIDDEN	0x02		/* Hidden file */
#define	FA_SYS		0x04		/* System file */
#define	FA_LABEL	0x08		/* Volume label */
#define	FA_DIR		0x10		/* Directory */
#define	FA_ARCH		0x20		/* Archive */

/*		Field attributes.				*/
#define	FLD_NORMAL	0
#define	FLD_AUTORET	0x0001
#define	FLD_NOREDSP	0x0002
#define	FLD_HIDE	0x0004
#define	FLD_LFRET	0x0008
#define	FLD_RTRET	0x0010
#define	FLD_CLR_ON_FST	0x0020
#define	FLD_ALTERD	0x0100
#define	FLD_VARYING	0x0200

/*	Field return codes for 'Special_key()' function.	*/

#define	FLDRC_IGNORE	0
#define	FLDRC_DONE	-1
#define	FLDRC_FST	-2
#define	FLDRC_NXT	-3
#define	FLDRC_PRV	-4
#define	FLDRC_LST	-5
#define	FLDRC_ERASE	-6
#define	FLDRC_INITSTR	-7

/*	Here are the MSDOS bits for the MSDOS mode portion.	*/

#define	FO_RDONLY	0x01

/*	cursor key codes	*/

#define K_END		1
#define K_DOWN		2
#define K_PGDOWN    	3
#define K_LF		4
#define K_RT		6
#define K_HOME    	7
#define K_UP		8
#define K_PGUP    	9
#define	K_CTLEND	11
#define	K_CTLPGDOWN	13
#define	K_CTLLF		14
#define	K_CTLRT		16
#define	K_CTLHOME	17
#define	K_CTLPGUP	19
#define	K_SHIFTTAB	20

/*	edit key codes		*/

#define K_INSERT	1
#define K_DEL		2
#define	K_CTLPRTSC	3
#define	K_STAR_NUMPAD	4
#define	K_MINUS_NUMPAD	5
#define	K_PLUS_NUMPAD	6
#define	K_CTL_BRK	7	/* <cntl><break> = <edit-key,7> */

/*		Key types		*/

#define	KB_ASCII  	0
#define	KB_CSR 		1
#define	KB_FNC  	2
#define	KB_EDIT 	3
#define	KB_ALT  	4

/*		Use with KbSource() to indicate source of keystrokes	*/

#define	KB_BIOS		0	
#define	KB_DOS		1
#define	KB_STDIN	2

/*	for building constants for comparisons		*/

#define	FNC_KEY(code)	(MAKEWORD(KB_FNC,(code)))
#define	EDIT_KEY(code)	(MAKEWORD(KB_EDIT,(code)))
#define	ASCII_KEY(code)	(MAKEWORD(KB_ASCII,(code)))
	/*Use only with capital alpha's, e.g. CTL_KEY('L') */
#define	CTL_KEY(code)	(ASCII_KEY((code)-'A'+1))
#define	CSR_KEY(code)	(MAKEWORD(KB_CSR,(code)))
#define	ALT_KEY(code)	(MAKEWORD(KB_ALT,code))
 
#define	KEY_TYPE(key)	TOLOBYTE(key)
#define	KEY_CODE(key)	LOBYTE(key) 

/*
*
* These definitions describe the bits in the keyboard flag.
*
*	Bit	Subject matter	Meaning, when bit is 1
*	 7	Insert		state active
*	 6	Caps-lock	state active
*	 5	Num-lock	state active
*	 4	Scroll-lock	state active
*	 3	Alt shift	key depressed
*	 2	Ctl shift	key depressed
*	 1	left-hand shift	key depressed
*	 0	rt-hand shift	key depressed
*
**/

/*	KBD	-> key depressed			*/
/*	KBS	-> key state.				*/

#define	KBD_ALTSHIFT		0x08
#define	KBD_CTLSHIFT		0x04
#define	KBD_LFSHIFT		0x02
#define	KBD_RTSHIFT		0x01

#define	KBS_INSERT		0x80
#define	KBS_CAPS		0x40
#define	KBS_NUMLOCK		0x20
#define	KBS_SCROLLLOCK		0x10

/**	Function Return Codes **/

#define	RC_SUCCESS	(0)	/* Called function succeeded 		*/
#define	RC_FAIL		(-1)	/* Called function failed		*/
#define RC_EOF		(-1)	/* Signale END-OF-FILE EOF		*/

#define	RC_ESC		1	/* user ended input with <Esc> key. 	*/
#define	RC_ENTER	2	/* user ended by pressing <enter> key.	*/
#define	RC_SPECIAL	3	/* user terminated input by pressing special */
#define	RC_OVERFLW	4	/* field full; insert mode; autoreturn;	*/
				/*  cursor in middle of field; user typed ascii*/
#define	RC_LOOP		9999	
/* RC_LOOP is a special return code to signal that a processing loop should*/
/* continue as normal.  It is used in key input processing for field editing*/
/* and selection-by-cursoring input functions.				*/

#define	DB_FAIL		RC_FAIL
#define	DB_SUCCESS 	RC_SUCCESS

/*	Reserved Error Codes		*/

/*	-257 to -320	Miscellaneous		*/

#define	SE_BAD_OBJ	 (-257)/* Handle was not to proper type of object */
#define SE_OUTOFHEAP	 (-258)/* out of heap space during giveme() */
#define	SE_GIVEFAR	 (-259)
#define	SE_BADPORT	 (-260)

/*	-321 to -384	IO system		*/

#define SE_BADWRITE	 (-321)/* write error */
#define SE_BADREAD	 (-322)/* read error */
#define	SE_BADSEEK	 (-323)
#define	SE_REOPENERR	 (-324)/* could not reopen file */

/*	-385 to -448	Database system		*/

#define SE_BADPGID	 (-385)/* bad page id in record handle */
#define SE_BADCELLID	 (-386)/* bad cell id in record handle */
#define SE_NOFREEBUFS	 (-387)/* no free buffers in buffer pool */
#define SE_DBPGBAD	 (-388)/* smashed database page */
#define SE_DBOVRFLOW	 (-389)/* database file too big (>30 megabytes) */
#define	SE_RECTOOBIG	 (-390)/* Size of stored record bigger than page*/
#define	SE_BUFINCMPAT	 (-391)/* Buffer system already exists and is incompatible*/
				/* with needs of database system.*/
/* 	-449 to -512	B-tree Indexes		*/

#define SE_BADKEYTYP	 (-449)/* bad key type in compare */
#define SE_BADDELKEY	 (-450)/* error during key deletion */
#define	SE_BADBROOT	 (-451)/* Root of tree appears bad. */

/*	Justification types for strjust()	*/

#define	STR_LJUST 	0
#define	STR_RJUST 	1
#define	STR_CENTER 	2

/*	Symbol table wild card - ANY or IGNORE symbol class	*/

#define	SYT_ANY		0	/* when looking for a symbol of any type */

/**
*	screen attributes :
*
*	bit number   ON		    	OFF		MASK	CONSTANT
*
*	  0	     reverse video  	normal video  0X01	VA_NORMAL
*	  1	     high intensity 	low intensity 0X02	VA_HIINTY
*	  2	     blinking	    	no blinking   0x04	VA_BLINK
*	  3	     underline	    	normal fgd    0x08	VA_ULN
*	  8	     graphics chars	TTY mode      0x0100	VA_GRAPHICS
*	  9	     '^'-normal		'^'-special   0x0200	VA_CARET
*	 10	     '%'-normal		'%'-special   0x0400	VA_PCT
*	 
**/

#define	VA_NORMAL		0x00
#define	VA_REVVID		0x01
#define VA_HIINTY		0X02
#define VA_BLINK		0X04
#define VA_ULN			0x08
#define VA_GRAPHICS		0x0100
#define VA_CARET		0x0200
#define	VA_PCT	 		0x0400

/*	colors for color text modes   */

#define VC_BLACK    	0
#define VC_BLUE	    	1
#define	VC_GREEN    	2
#define	VC_CYAN	    	3
#define	VC_RED	    	4
#define	VC_MAGENTA	5
#define	VC_YELLOW	6
#define	VC_WHITE    	7

/*	Video drawing constants		*/

#define VD_NOATTR	-1  /* Don't use any attributes when displaying chars*/
#define VD_CURPOS	-1  /*Leave this cursor coord at its current value*/
#define VD_CURSTAT	-2
#define VD_ALLOFIT  0x7FFF

/*	video modes		*/

#define	VM_BW40			0
#define	VM_COLR40	 	1
#define	VM_BW80	 		2
#define	VM_COLR80		3
#define	VM_COLR320		4
#define VM_BW320		5
#define	VM_COLR640		6
#define	VM_MONOCHROME		7

/* Window Movement return code bit masks	*/
#define W_UNCHANGED	0
#define W_ALTERED	1
#define W_CHANGED	2

/* Window Movement type codes.			*/

#define W_POSABS 	0
#define W_POSREL 	1
#define W_BUFABS 	2
#define W_BUFREL 	3
#define W_SIZABS 	4
#define W_SIZREL 	5

/*	Xrec Open modes.		*/

#define	XR_READ		"r"
#define	XR_WRITE	"w"
#define	XR_APPEND	"a"
